var Blamer = require('./blamer.js');
var blamerInstance;
function findStatement (map, id) {

  var start = map[id].start.line;
  var end = map[id].end.line;
  var result = [];
  //for(var i = start; i <= end; i++) {     looks like it calculates some 
  //  result.push(i);                       lines multiple times
  //}
      result.push(start);
  return result;
}

function  blameFile (fileCoverage, basePath) {
  var notCovered = [], path;
  var statements, statement, map;
  path = basePath + fileCoverage.path.substr(1);

  statements = fileCoverage.s;
  map = fileCoverage.statementMap;
  if(map && statements){
    for (statement in statements) {
     if(statements[statement] === 0) {
      notCovered = notCovered.concat(findStatement(map, statement));
     }
    }
  }

  if(notCovered.length > 0){
    var data = blamerInstance.blame(path);
          fileCoverage.blame = blamerInstance.parser.getFullBlame(data,notCovered);
  }
}

function blameAllFiles (coverage, basePath, VCS) {
  blamerInstance = Blamer(VCS);
  var file;
  for (file in coverage){
    blameFile(coverage[file], basePath);
  }
}

module.exports = {
  blameAllFiles: blameAllFiles
}